(function () {
	window.bazingaApp.views.dragDropView = window.bazingaApp.views.abstractModuleView.extend({

		completionCheck: function (context, options) {
			var self = this;

			console.log("completionCheck");

			//console.log(options.tgtType);

			/*if(options.tgtType == 'video'){
			    //string completed
			    self.goNext();
			}*/
		},

		loaded: function () {
			var self = this;

			console.log(window.bazingaApp.models.api.getPageCompletion());

			if (window.bazingaApp.models.api.getPageCompletion() != "c") {
				$("#nextBtn").addClass("is-disabled");
			}
			self.dragAssess();

		},
		/* drag n drop */

		/*dragDrop: function() {
			console.log("dragDrop");
            //initialise drag items
            $(".btn-drag").draggable({
                revert: "invalid",
                containment: ".dragAndDropContainer",
                cursor: "move",
                snap: ".drop-target",
                snapMode: "inner"
            });

            //initialise drop items
            $(".drop-target").droppable({
                hoverClass: "hover",
                drop: function(event, ui) {
                    var show = $(ui.draggable).data("dragShow"),
                        hide = $(ui.draggable).data("dragHide")
                        //$( show ).fadeIn(300);
                        //$( hide ).fadeOut(300);
                    $(show + " .mejs-play").trigger('click');
                    ui.draggable.addClass("viewed");
                    ui.draggable.draggable('option', 'revert', true);
                    checkScreenComplete();
                }
            });
			
			//keyboard version
			console.log("sdd");
			$( ".btn-drag" ).keypress(function(e) {
				conosole.log("press");
				console.log(e.keyCode );
  				if ( e.which == 13 ) {
     				console.log("s");
  				}
			});
			
        },*/

		randomize: function (selector) {
			var parent = $(selector);
			var divs = parent.children();
			while (divs.length) {
				parent.append(divs.splice(Math.floor(Math.random() * divs.length), 1)[0]);
			}
		},

		initDrop: function (dragObj, dropObj) {

			var show = $(dragObj).data("dragShow"),
				hide = $(dragObj).data("dragHide"),
				answer = $(dragObj).data("dragAnswer"),
				dragID = $(dragObj).data("dragId"),
				dropID = $(dropObj).data("dropId");
			/*droppedOn = $(dropObj).attr("id");*/

			console.log("initdrop " + $(dragObj).attr("id") + " on " + $(dropObj).attr("id"));

			//$(".change-img").hide();

			// if matched in ordered area
			if (dropObj.parent().hasClass("dropzone")) {
				/*$( show ).fadeIn(300);
				$( hide ).fadeOut(300);*/
				$(dragObj).addClass("viewed");
				// if matched in default area
			} else {
				/*$( show ).hide();
				$( hide ).show();*/

				$(dragObj).removeClass("viewed");
			}

			/*$(dragObj).position({
			    my: 'left top',
			    at: 'left top',
			    of: $(dropObj)
			});*/

			$(dragObj).css("left", 0);
			$(dragObj).css("top", 0);

			if (dragID == dropID) {
				$(dragObj).addClass("correct");
			} else {
				$(dragObj).removeClass("correct");
			}
			console.log("end initdrop");
		},

		initDropDone: function () {
			var dragNum = $(".btn-drag").length,
				dropNum = $(".viewed").length;
			//alert(dragNum +"+"+ dropNum);
			if (dragNum == dropNum) {
				//all items matched in
				$(".btn-submit").removeClass("is-disabled");
				$(".auto-drop").droppable("option", "disabled", true);
			} else {
				$(".btn-submit").addClass("is-disabled");
			}
		},
		dragAssess: function () {

			var self = this;

			console.log("dragAssess");

			self.randomize("#draggables");
			$(".btn-submit").addClass("is-disabled");

			//initialise drag items
			$(".btn-drag").draggable({
				cancel: false,
				containment: ".drag-container",
				cursor: "move",
				snap: ".drop-target",
				snapMode: "inner",
				revert: "invalid",
				start: function (event, ui) {
					$(this).css("z-index", "800");
					console.log("width "+$(this).outerWidth());
					$(this).css("width",$(this).outerWidth());
				},
				stop: function (event, ui) {
					$(this).css("z-index", "600");
				}
			});

			//initialise drop items
			$(".drop-target").droppable({
				hoverClass: "hover",
				drop: function (event, ui) {
					var dropped = $(".viewed").length,
						selected = $(ui.draggable).attr("id");
					console.log("selected = " + selected);
					$(".auto-drop").droppable("option", "disabled", false);
					
					if (!$(this).hasClass("auto-drop")) {
						//console.log("not auto drop"); default
						if ($(this).children(".btn-drag").length) {
							//unused for now
							/*var prevDrop = $(ui.draggable).parent(), //drop from new drag object
							    currentDrag = $(this).find(".btn-drag"); //existing drag object 

							console.log("existing item - prev drop = " + prevDrop.attr("id") + "& prev drag = " + currentDrag.attr("id"));

							currentDrag.appendTo(prevDrop);
							$(ui.draggable).appendTo(this);

							self.initDrop($(ui.draggable), $(this));
							self.initDrop(currentDrag, prevDrop);*/
						} else {
							$(ui.draggable).appendTo(this);
							self.initDrop($(ui.draggable), $(this));
						}
					} else {
						//unused for now
						//console.log("auto drop");
						/*for (var i = 1; i <= drags; i++) {
						    var occupied = $("#drop" + i).children(".btn-drag").attr("id");
						    //console.log("occupied ="+occupied);
						    if (typeof occupied == 'undefined') {
						        $(ui.draggable).appendTo("#drop" + i);
						        initDrop($(ui.draggable), $("#drop" + i));
						        initDropDone();
						        return;
						    }
						}*/
					}
					self.initDropDone();
				}
			});

			//keyboard version

			$(".btn-drag").on("click keyup",function (e) {
				console.log(e.which);
				if (e.which == 13 || e.which == 32 || e.which == 1) {

					console.log("drag pressed");

					var $currentBtn = $(".current-drag");

					if ($(".current-drag").length > 0) {

						console.log("already current");

						//already selected, swap them
						if ($(this).parents('.drop-target').length) {
							//existing dropped, take out
							var $existingBtn = $(this);
							$currentBtn.removeClass("current-drag");
							$currentBtn.appendTo($existingBtn.parent());
							self.initDrop($currentBtn, $existingBtn.parent());

						}

					} else {
						$('html, body').animate({
							scrollTop: $("#droppables").offset().top - $(".dragAndDropQuestionContainer").data("scrollOffset")
						}, 500);
					}
					
					
					$(this).css("width",$(this).outerWidth());
					
					$(this).addClass("current-drag");
					$(this).appendTo($("#currentDrag"));
					self.initDrop($(this), $("#currentDrag"));
					
					self.initDropDone();

					//$("#droppables").focus();


				}
			});

			$("#droppables .drop-target").on("click keyup",function (e) {
				if (!$(e.target).hasClass("btn-drag") && !$(e.target).parent().hasClass("btn-drag")) {
					if (e.which == 13 || e.which == 32 || e.which == 1) {
						console.log("drop pressed");
						if ($(".current-drag").length > 0) {
							console.log("current drop exists");

							var $currentBtn = $(".current-drag");
							var $existingBtn;
							var scroll = true;

							$currentBtn.removeClass("current-drag");

							if ($(this).find(".btn-drag").length > 0) {
								console.log("drop already contains a drag. swap");
								$existingBtn = $(this).find(".btn-drag");
								scroll = false;
 
								var existingBtnId = $existingBtn.data("dragId");
								var currentBtnId = $currentBtn.data("dragId");

								console.log("existing id:" + existingBtnId);
								console.log("current id:" + currentBtnId);

								if (existingBtnId != currentBtnId) {
									//current is already in this drop
									console.log("not same btn");
									$existingBtn.addClass("current-drag");
									$existingBtn.appendTo($("#currentDrag"));
									self.initDrop($existingBtn, $("#currentDrag"));
								}
							}

							$currentBtn.prependTo(this);
							self.initDrop($currentBtn, $(this));

							self.initDropDone();
							
							if($("#draggables .btn-drag").length > 0 && scroll){
									console.log("scroll to draggable");
									$('html, body').animate({
										scrollTop: $("#draggables").offset().top - $(".dragAndDropQuestionContainer").data("scrollOffset")
									}, 500);
								}

							/*if($("#draggables .btn-drag").length > 0){
								console.log("still more to drag");
								$("#draggables").focus();
							}*/

						}
					}
				}
			});

			//submit
			$(".btn-submit").click(function () {
				console.log("match submit");
				var correct = $(".correct").size(),
					items = $(".btn-drag").size(),
					drops = $("#droppables .drop-target").size();

				if ($(this).hasClass("is-disabled")) {
					return;
				}

				$(".js-hide-next").fadeOut(300);

				$(".btn-drag.correct .tick").show();
				$(".completeHide").hide();
				$(".feedback").delay(300).fadeIn(300);

				window.bazingaApp.models.api.setPageCompletion('completed');
				if (correct == items) {
					console.log("correct");
					$(".btn-drag").draggable("option", "disabled", true);
					$(".feedback-waf").hide();
					window.bazingaApp.models.api.setPageScore(100);
				} else {
					console.log("wrong");
					$(".feedback-caf").hide();
					$(".btn-drag").draggable("option", "disabled", true);
					for (var i = 1; i <= drops; i++) {
						$("#drag" + i)
							/*.position({
							                    of: $("#drop"+i),
							                    my: 'left top',
							                    at: 'left top'
							                })*/
							.css("z-index", "10");
					}

					$(".btn-show-correct").show();

				}
				$(this).addClass("is-disabled");
				self.completionCheck(); //setcompletion
				$("#nextBtn").removeClass("is-disabled");
				$(".btn-show-correct").removeClass("is-disabled");
			})

			$(".btn-submit").keypress(function (e) {

				if (e.which == 13 || e.which == 32) {
					$(".btn-submit").click();
				}
			});

			$(".btn-show-correct").click(function () {
				if (!$(this).hasClass("is-disabled")) {
					console.log("show correct");
					var correct = $(".correct").size(),
						items = $(".btn-drag").size(),
						drops = $("#droppables .drop-target").size();

					for (var i = 1; i <= drops; i++) {
						$("#drag" + i)
							.position({
								of: $("#drop" + i),
								my: 'left top',
								at: 'left top'
							})
							.css("z-index", "10");
					}
				}
			});

			$(".btn-show-correct").keypress(function (e) {

				if (e.which == 13 || e.which == 32) {
					$(".btn-show-correct").click();
				}
			});

		}



	});

	window.pageIntialized = false;
	$(document).ready(function () {
		window.bazingaApp.dragDropView = new window.bazingaApp.views.dragDropView();
		window.bazingaApp.dragDropView.load();
		//dont put js scripts in here . use the pageview.loaded function to start initializing page level functionalities
	});
}());
